--- conf/LINUX.def
+++ conf/LINUX.def
@@ -14,7 +14,10 @@
 #
 ARCHCFLAGS	=	-DSYSVSIGNAL -DNOWAIT3 -DRSHCOMMAND=\"/usr/bin/rsh\" \
 				-DNEEDENDIAN -DFDSETNOTSTRUCT -DHASERRORVARS \
-				-DCTIMEISTIMET -DSYSERRISCONST -DNOTMPNAM -DUSESTRERROR
+				-DCTIMEISTIMET -DSYSERRISCONST -DNOTMPNAM -DUSESTRERROR \
+                                -DHASREADLINE -DLINUX -DPVMDPATH=\"pvmd\" \
+                                -DPVMDFILE=\"/usr/bin/pvmd\" \
+                                -DPVM_DEFAULT_ROOT=\"/usr/lib/pvm3\" -DOVERLOADHOST
 #
 # For Absoft Fortran 95 Compiler:
 # ARCHFFLAGS	=	-B108 -YEXT_NAMES="LCS"
@@ -22,7 +25,7 @@
 #
 ARCHDLIB	=
 ARCHDOBJ	=
-ARCHLIB		=
+ARCHLIB		=       -lreadline -lncurses
 HASRANLIB	=	t
 AR			=	ar
 PVM_ARCH	=	LINUX
--- conf/LINUX64.def
+++ conf/LINUX64.def
@@ -21,10 +21,11 @@
 #
 ARCHCFLAGS	=	-DSYSVSIGNAL -DNOWAIT3 -DRSHCOMMAND=\"/usr/bin/rsh\" \
 				-DNEEDENDIAN -DFDSETNOTSTRUCT -DHASERRORVARS \
-				-DHASSTDLIB -DCTIMEISTIMET -DSYSERRISCONST -DNOTMPNAM
+				-DHASSTDLIB -DCTIMEISTIMET -DSYSERRISCONST -DNOTMPNAM \
+                                -DHASREADLINE 
 ARCHDLIB	=
 ARCHDOBJ	=
-ARCHLIB		=
+ARCHLIB		=       -lreadline -lncurses
 HASRANLIB	=	t
 AR			=	ar
 PVM_ARCH	=	LINUX64
--- conf/LINUXALPHA.def
+++ conf/LINUXALPHA.def
@@ -15,10 +15,10 @@
 ARCHCFLAGS	=	-DNOWAIT3 -DNOUNIXDOM -DCTIMEISTIMET -DSYSERRISCONST \
 				-DRSHCOMMAND=\"/usr/bin/rsh\" -DNEEDENDIAN \
 				-DHASSTDLIB -DSYSVSTR -DHASERRORVARS -DFDSETNOTSTRUCT \
-				-DSOCKLENISUINT -DNOTMPNAM
+				-DSOCKLENISUINT -DNOTMPNAM -DHASREADLINE
 ARCHDLIB	=
 ARCHDOBJ	=
-ARCHLIB		=
+ARCHLIB		=       -lreadline -lncurses
 HASRANLIB	=	t
 AR			=	ar
 PVM_ARCH	=	LINUXALPHA
--- conf/LINUXPPC.def
+++ conf/LINUXPPC.def
@@ -13,10 +13,11 @@
 #	must also add "-lncurses" to the ARCHLIB define.
 #
 ARCHCFLAGS	=	-DRSHCOMMAND=\"/usr/bin/rsh\" \
-				-DNEEDENDIAN -DFDSETNOTSTRUCT -DHASERRORVARS -DNOTMPNAM
+				-DNEEDENDIAN -DFDSETNOTSTRUCT -DHASERRORVARS -DNOTMPNAM \
+                                -DHASREADLINE
 ARCHDLIB	=
 ARCHDOBJ	=
-ARCHLIB		=
+ARCHLIB		=       -lreadline -lncurses
 HASRANLIB	=	t
 AR			=	ar
 PVM_ARCH	=	LINUXPPC
--- conf/LINUXSPARC.def
+++ conf/LINUXSPARC.def
@@ -14,10 +14,10 @@
 #
 ARCHCFLAGS	=	-DSYSVSIGNAL -DNOWAIT3 -DRSHCOMMAND=\"/usr/bin/rsh\" \
 				-DNEEDENDIAN -DCTIMEISTIMET -DFDSETNOTSTRUCT \
-				-DHASERRORVARS -DNOTMPNAM
+				-DHASERRORVARS -DNOTMPNAM -DHASREADLINE
 ARCHDLIB	=
 ARCHDOBJ	=
-ARCHLIB		=
+ARCHLIB		=       -lreadline -lncurses
 HASRANLIB	=	t
 AR			=	ar
 PVM_ARCH	=	LINUXSPARC
--- console/cons.c
+++ console/cons.c
@@ -735,8 +735,8 @@
 /* Provided by Edward Vigmond <vigmonde@IGB.UMontreal.CA> */
 
 
-char *command_generator __ProtoGlarp__(( char *, int ));
-char *command_help_generator __ProtoGlarp__(( char *, int ));
+char *command_generator __ProtoGlarp__(( const char *, int ));
+char *command_help_generator __ProtoGlarp__(( const char *, int ));
 
 /*
  * readline has detected a complete input line
@@ -788,7 +788,7 @@
 			last_line = (char *) NULL;
 		}
 
-		matches = completion_matches( text, command_generator );
+		matches = rl_completion_matches( text, command_generator );
 
 	}
 
@@ -797,7 +797,7 @@
 
 		if ( !last_line || strcmp( last_line, rl_line_buffer ) ) {
 
-			matches = completion_matches( text,
+			matches = rl_completion_matches( text,
 				command_help_generator );
 
 			if ( last_line ) free( last_line );
@@ -813,7 +813,7 @@
 /* function to match partially completed command names */
 char *
 command_generator( text, state )
-char *text;
+const char *text;
 int state;
 {
 	static int list_index, len;
@@ -843,7 +843,7 @@
  */
 char *
 command_help_generator( text, state )
-char *text;
+const char *text;
 int state;
 {
 	static int list_index, len, found_one;
--- lib/pvmgetarch
+++ lib/pvmgetarch
@@ -76,6 +76,9 @@
 	Linux,hp_pa )           ARCH=LINUXHPPA ;;
 	Linux,ppc )             ARCH=LINUXPPC ;;
 	Linux,m68k )            ARCH=LINUXATARI ;;
+        Linux,s390* )           ARCH=LINUXS390 ;;
+        Linux,ppc64 )           ARCH=LINUXPPC64 ;;
+        Linux,parisc )          ARCH=LINUXHPPA ;;
 	BSD/OS,i[3456]86 )      ARCH=BSD386 ;;
 	FreeBSD,i[3456]86 )     ARCH=FREEBSD ;;
 	FreeBSD,alpha )         ARCH=FREEBSD ;;
